type
  U8 = byte;
  U32 = cardinal;
  U16 = word;
  U64 = UInt64;

  pU8 = ^U8;
  pU32 = ^U32;
  pU16 = ^U16;
  pU64 = ^U64;

  w128_t = packed record
    case byte of
      0:
        (q: packed array [0 .. 1] of u64);
      1:
        (b: packed array [0 .. 15] of u8);
  end;

     pw128_t =  ^w128_t;

   w256_t = packed record
    case byte of
      0:
        (q: packed array [0 .. 3] of u64);
      1:
        (b: packed array [0 .. 31] of u8);
  end;



   pw256_t =  ^w256_t;

  kuz_key_t = packed record
    k: packed array [0 .. 9] of w128_t;
  end;

   Pkuz_key_t = ^  kuz_key_t;
